#include "lswhitebox.h"

extern WndInfo theWnd;

const char *togglestrings[] = { "toggle", "on", "yes", "true" };


void BangMove(HWND, LPCSTR args)
{
	char one[MAX_LINE_LENGTH],two[MAX_LINE_LENGTH],three[MAX_LINE_LENGTH];
	char *x=one,*y=two;
	char *tokens[] = { one,two,three };

	WndInfo *w = &theWnd;

	*one = *two = *three = 0;
	LCTokenize(args,tokens,3,NULL);

	if (*one>='A')
	{
		w->Monitor = LSGetMonitor(one);
		LSGetMonitorScreenRect(w->Monitor,&w->rMonitor);
		x=two; y=three;
	}

	w->Pos.x = ParseCoordinate(x,w->Pos.x,w->rMonitor.right-w->rMonitor.left);
	w->Pos.y = ParseCoordinate(y,w->Pos.y,w->rMonitor.bottom-w->rMonitor.top);

	UpdateWndPos(w);
}

void BangSize(HWND, LPCSTR args)
{
	char one[MAX_LINE_LENGTH],two[MAX_LINE_LENGTH];
	char *tokens[] = { one,two };

	WndInfo *w = &theWnd;

	*one = *two = 0;
	LCTokenize(args,tokens,2,NULL);

	w->Size.cx = ParseCoordinate(one,w->Size.cx,w->rMonitor.right-w->rMonitor.left);
	w->Size.cy = ParseCoordinate(two,w->Size.cy,w->rMonitor.bottom-w->rMonitor.top);

	UpdateWndPos(w);
}

void ParseToggleFlag(LPCSTR flag,bool *res,int defaction,bool iftrue)
{
	int action = defaction;

	if (flag && *flag) action = LSStringEnum(flag,togglestrings);

	switch (action)
	{
	case 0: *res = !*res; break;
	case -1: *res = !iftrue; break;
	default: *res = iftrue; break;
	}
}

void BangOnTop(HWND, LPCSTR args)
{
	WndInfo *w = &theWnd;

	ParseToggleFlag(args,&w->bOnTop,0,true);
	UpdateWndOnTop(w);
}

void BangAlpha(HWND, LPCSTR args)
{
	WndInfo *w = &theWnd;

	if (args) w->Alpha = ParseCoordinate((LPSTR)args,w->Alpha,255);
	RedrawWnd(w);
}

void BangShow(HWND, LPCSTR args)
{
	WndInfo *w = &theWnd;

	ParseToggleFlag(args,&w->bHidden,1,false);
	UpdateWndHidden(w);
}

void BangLoadBoxHook(HWND, LPCSTR args)
{
	char one[MAX_LINE_LENGTH],two[MAX_LINE_LENGTH],three[MAX_LINE_LENGTH];
	char *tokens[3] = { one, two, three },*p;
	const char *rest;
	int i;
	FILE *f;
	WndInfo *w = &theWnd;
	Config c;

	rest = args;
	if (args && *args)
	{
		while (GetToken(rest,tokens[0],&rest,FALSE))
		{
			p = tokens[0];
			tokens[0] = tokens[1];
			tokens[1] = tokens[2];
			tokens[2] = p;
		}
		// tokens[2] = window handle (use atoi if you link to crt)
		i = 0;
		while (*tokens[2])
		{
			i = i*10 + *tokens[2]-'0';
			++tokens[2];
		}
		w->hParentWnd = (HWND)i;
		ZeroMemory(&c,sizeof(Config));
		if (!Module.bWaitForBox)
			DestroyWindow(w->hWnd);
		// tokens[1] = box file
		if (*tokens[1]==0 || (f = LCOpen(tokens[1])))
		{
			ReadConfigWnd(w,&c,"WhiteBox",8);
			if (f) LCClose(f);
		}
		CreateWnd(w);
		ShowWindow(w->hWnd,SW_SHOWNA);
	}
}


// bang command list

lsBangCmdDef Bangs[] = {
	{ "Move", BangMove },
	{ "Size", BangSize },
	{ "OnTop", BangOnTop },
	{ "Alpha", BangAlpha },
	{ "Show", BangShow },
	{ "LoadBoxHook", BangLoadBoxHook },
	NULL, NULL
};

