#include "lswhitebox.h"

const char * const ModuleName = "lsWhiteBox";
const char * const ModuleVersion = "1.0";
const char * const ModuleAuthor = "RabidCow";

extern "C" {
__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
__declspec( dllexport ) int quitModule(HINSTANCE dll);
__declspec( dllexport ) int initWharfModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType *wd);
__declspec( dllexport ) int quitWharfModule(HINSTANCE dllInst);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

WndInfo theWnd;
ModInfo Module;

BOOL  (WINAPI *dAlphaBlend)( IN HDC, IN int, IN int, IN int, IN int,
    IN HDC, IN int, IN int, IN int, IN int, IN BLENDFUNCTION) = NULL;
BOOL (WINAPI *dUpdateLayeredWindow)(HWND,HDC,POINT*,SIZE*,HDC,POINT*,
		COLORREF,BLENDFUNCTION*,DWORD) = NULL;

#define LINKLIB(name) { name, NULL },
#define LINKFUNC(name,ptr) { name, reinterpret_cast<int**>(&ptr) },

lsLinkItem DynFuncs[] =
{
	LINKFUNC("UpdateLayeredWindow",dUpdateLayeredWindow)

	LINKLIB("MSIMG32.DLL")
	LINKFUNC("AlphaBlend",dAlphaBlend)

	/* end of list marker */ 
	{ NULL, NULL }
};

int initModuleEx(HWND ParentWnd, HINSTANCE dll, LPCSTR szPath)
{
	Config c;

	ZeroMemory(&Module,sizeof(ModInfo));
	Module.hInstance = dll;
	LSLinkFunctions(DynFuncs);

	WNDCLASS wc;
	ZeroMemory(&wc,sizeof(WNDCLASS));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpfnWndProc = &WndProc;
	wc.hInstance = dll;
	wc.lpszClassName = ModuleName;
	wc.cbWndExtra = sizeof(WndInfo *);
	if (!RegisterClass(&wc)) 
	{
		MessageBox(ParentWnd,
			"Error registering window class.\n\nPerhaps the module did not unload properly?",
			ModuleName,MB_OK|MB_ICONERROR);
		return 1;
	}

	ZeroMemory(&theWnd,sizeof(WndInfo));
	ZeroMemory(&c,sizeof(Config));

	if (ParentWnd == GetLitestepWnd())
		// using the litestep window as a parent will get me dropped behind
		// the desktop if i'm in "always on bottom" mode, so use the desktop
		Module.hBottomParentWnd = NULL;
	else
		Module.hBottomParentWnd = ParentWnd;
	if (!Module.hBottomParentWnd)
		Module.hBottomParentWnd = FindWindow("DesktopBackgroundClass", NULL);
	if (!Module.hBottomParentWnd)
		Module.hBottomParentWnd = GetDesktopWindow();

	theWnd.hParentWnd = Module.hBottomParentWnd;
	ReadConfigMod(&Module,&c,"WhiteBox",8);

	if (!Module.bWaitForBox)
	{
		ReadConfigWnd(&theWnd,&c,"WhiteBox",8);
		if (!CreateWnd(&theWnd)) return 1;
		if (!theWnd.bHidden) ShowWindow(theWnd.hWnd,SW_SHOWNA);
	}

	LSRegisterBangList("!WhiteBox",9,Bangs);

	return 0;
}

int quitModule(HINSTANCE dll)
{
	LSRemoveBangList("!WhiteBox",9,Bangs);
	DestroyWindow(theWnd.hWnd);
	UnregisterClass(ModuleName,Module.hInstance);

	LSUnlinkFunctions(DynFuncs);

	return 0;
}

int initWharfModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType *wd)
{
	return initModuleEx (ParentWnd, dllInst, (wd) ? wd->lsPath : NULL);
}

int quitWharfModule(HINSTANCE dllInst)
{
	return quitModule(dllInst);
}
