#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <lsapi.h>
#include "..\AggressiveOptimize.h"

#ifdef LS_AUTHORIZATION_UNAVAILABLE
#error Wrong LSAPI.H.  Make sure the path is right.
#endif

extern const char * const ModuleName;
extern const char * const ModuleVersion;
extern const char * const ModuleAuthor;

extern lsBangCmdDef Bangs[];

extern
BOOL  (WINAPI *dAlphaBlend)( IN HDC, IN int, IN int, IN int, IN int,
    IN HDC, IN int, IN int, IN int, IN int, IN BLENDFUNCTION);
extern
BOOL (WINAPI *dUpdateLayeredWindow)(HWND,HDC,POINT*,SIZE*,HDC,POINT*,
		COLORREF,BLENDFUNCTION*,DWORD);

#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED           0x00080000
#define ULW_COLORKEY            0x00000001
#define ULW_ALPHA               0x00000002
#define ULW_OPAQUE              0x00000004
#endif

#define UGWL_WNDINFO_PTR 0

struct WndInfo {
	HWND hWnd;
	HWND hParentWnd;

	POINT Pos;
	SIZE Size;
	LSMONITOR Monitor;
	RECT rMonitor;

	LONG Alpha;

	bool bFakeAlpha;
	bool bOnTop;
	bool bHidden;

	HBITMAP hbmBackBuffer;
};

struct ModInfo {
	bool bWaitForBox;
	HWND hBottomParentWnd;
	HINSTANCE hInstance;
};

extern ModInfo Module;

struct Config {
	char key[256];
	int keylen;

	char one[MAX_LINE_LENGTH],two[MAX_LINE_LENGTH],
		three[MAX_LINE_LENGTH],four[MAX_LINE_LENGTH];
	char *tokens[4];
	char line[MAX_LINE_LENGTH];
};

class ConfigState {
public:
	int keylen;
	Config *config;

	ConfigState(Config *c,const char *key,int len) : config(c),keylen(len)
		{ lstrcpyn(config->key+config->keylen,key,len+1); config->keylen+=keylen; }
	~ConfigState()
		{ config->keylen-=keylen; config->key[config->keylen]=0; }
};

// read configuration for the whole module
void ReadConfigMod(ModInfo *m,Config *c,const char *key,int keylen);
// read configuration for a window
void ReadConfigWnd(WndInfo *w,Config *c,const char *key,int keylen);

// create a window and mark it as part of litestep
bool CreateWnd(WndInfo *w);
// update size and position of window
void UpdateWndPos(WndInfo *w);
// update on top/bottem setting
void UpdateWndOnTop(WndInfo *w);
// update hide/show
void UpdateWndHidden(WndInfo *w);

// paint the window
void PaintWnd(WndInfo *w,HDC hdc);
void RedrawWnd(WndInfo *w);


