#include "lswhitebox.h"

static void ReadMonitor(Config *c,const char *key,int keylen,LSMONITOR *res)
{
	ConfigState cs(c,key,keylen);
	if (GetRCString(c->key,c->line,"",MAX_LINE_LENGTH))
		*res = LSGetMonitor(c->line);
}

static void ReadCoord(Config *c,const char *key,int keylen,LONG *res,LONG max)
{
	ConfigState cs(c,key,keylen);
	*res = GetRCCoordinate(c->key,*res,max);
}

static void ReadBool(Config *c,const char *key,int keylen,bool *res)
{
	ConfigState cs(c,key,keylen);
	*res = FALSE!=GetRCBoolDef(c->key,*res?TRUE:FALSE);
}

static void ReadInt(Config *c,const char *key,int keylen,int *res)
{
	ConfigState cs(c,key,keylen);
	*res = GetRCInt(c->key,*res);
}

void ReadConfigMod(ModInfo *m,Config *c,const char *key,int keylen)
{
	ConfigState cs(c,key,keylen);

	m->bWaitForBox = false;
	ReadBool(c,"InBox",5,&m->bWaitForBox);
}

void ReadConfigWnd(WndInfo *w,Config *c,const char *key,int keylen)
{
	ConfigState cs(c,key,keylen);

	if (w->hParentWnd != Module.hBottomParentWnd)
	{
		w->Monitor = LSMONITOR_NONE;
		GetWindowRect(w->hParentWnd,&w->rMonitor);
	}
	else
	{
		w->Monitor = LSGetMonitor(NULL);
		ReadMonitor(c,"OnMonitor",9,&w->Monitor);
		LSGetMonitorScreenRect(w->Monitor,&w->rMonitor);
	}

	w->Pos.x = w->Pos.y = 0;
	ReadCoord(c,"X",1,&w->Pos.x,w->rMonitor.right-w->rMonitor.left);
	ReadCoord(c,"Y",1,&w->Pos.y,w->rMonitor.bottom-w->rMonitor.top);

	if (w->hParentWnd != Module.hBottomParentWnd)
	{
		w->Size.cx = w->rMonitor.right-w->rMonitor.left-w->Pos.x;
		w->Size.cy = w->rMonitor.bottom-w->rMonitor.top-w->Pos.y;
	}
	else
	{
		w->Size.cx = w->Size.cy = 100;
	}
	ReadCoord(c,"Width",5,&w->Size.cx,w->rMonitor.right-w->rMonitor.left);
	ReadCoord(c,"Height",6,&w->Size.cy,w->rMonitor.bottom-w->rMonitor.top);

	w->Alpha = 255;
	ReadCoord(c,"Alpha",5,&w->Alpha,255);

	w->bFakeAlpha = false;
	ReadBool(c,"FakeAlpha",9,&w->bFakeAlpha);

	w->bOnTop = false;
	ReadBool(c,"OnTop",5,&w->bOnTop);

	w->bHidden = false;
	ReadBool(c,"Hidden",6,&w->bHidden);
}

