#include "lswhitebox.h"

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	WndInfo *w = (WndInfo *)GetWindowLong(hwnd,UGWL_WNDINFO_PTR);
	switch (message) {
	case WM_SHOWWINDOW:
		{
			HDC hdcScreen = GetDC(NULL);

			if (w->hbmBackBuffer==NULL)
				w->hbmBackBuffer = CreateCompatibleBitmap(hdcScreen,w->Size.cx,w->Size.cy);

			ReleaseDC(NULL,hdcScreen);

			RedrawWnd(w);
		}
		break;

	case WM_DESTROY:
		{
			if (w->hbmBackBuffer!=NULL) DeleteObject(w->hbmBackBuffer);
		}
		break;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd,&ps);
			HDC hdcWnd = CreateCompatibleDC(hdc);
			HBITMAP hbmOld = (HBITMAP)SelectObject(hdcWnd,w->hbmBackBuffer);

			BitBlt(hdc,0,0,w->Size.cx,w->Size.cy,hdcWnd,0,0,SRCCOPY);

			SelectObject(hdcWnd,hbmOld);
			DeleteDC(hdcWnd);

			EndPaint(hwnd,&ps);
		}
		break;

	default:
		return DefWindowProc(hwnd,message,wParam,lParam);
	}

	return 0;
}